;SPDEX2                                
;                '99.4.26              
;                                      
;                                      
;I/O  C4 D0 -- 0=CCW  ,1=CW            
;        D1 -- Low Speed               
;        D2 -- Mid Speed               
;        D3 -- High Speed              
;        D4 -- Start                   
;        D5 --                         
;     C0 D0 -- Brake Open              
;                                      
;User /P                               
;No.0  Low Speed HZP    $FE50,1        
;   1  Mid Speed HZP    $FE52,3        
;   2  High Speed HZP   $FE54,5        
;   3  UP SFT           $FE56,7        
;   4  Down SFT         $FE58,9        
;                                      
;                                      
G00  CALL $464                         
     CALL $490                         
     POKE $FF02 1                      
;                                      
G10  A0=C4                             
     JNE I00 A0 AND 16  ;Start?        
     NOP                               
     JMP G10                           
;                                      
;----- Start -----                     
;                                      
I00  JEQ G10 A0 AND $0E                 
     JSR Z00                           
;                                      
I02  A1=1                              
     JEQ I04 A0 AND 1  ;CCW CW ?       
     A1=-1                             
I04  A2=A0 AND $0E                      
     JEQ I06 A2 AND 8  ;High Speed?    
     DPEEK A4 $FE54                    
     JMP I10                           
I06  JEQ I08 A2 AND 4  ;Mid Speed?     
     DPEEK A4 $FE52                    
     JMP I10                           
I08  JEQ I09 A2 AND 2  ;Lo Speed       
     DPEEK A4 $FE50                    
     JMP I10                           
I09  A4=0                              
;                                      
I10  A6=A4*A1                          
     JEQ I16 HZP-A6                    
I11  JPL I12 ABS HZS-ABS A5            
;                                      
     DPEEK A5 $FE56  ;Up S Gain        
     JMP I14                           
;                                      
I12  DPEEK A5 $FE58  ;Dw S Gain        
;                                      
I14  SFT=A5          ;SFT Set          
;                                      
I16  A0=C4                             
     JEQ I20 A0 AND 16  ;Stop?         
     HZP=A6                            
     JMP I02                           
;                                      
;-----  Stop -----                     
;                                      
I20  DPEEK A5 $FE58  ;Dw S Gain        
     SFT=A5          ;SFT Set          
     JSR Z10                           
     JMP G10                           
;                                      
;----- Sub routine -----               
;                                      
;                                      
;----- Power On -----                  
;                                      
Z00  SEVCC=1                           
     TIC1=40                           
Z02  JNE Z02 TIC1                      
     C0=C0 OR 1                        
     TIC1=80                           
Z04  JNE Z04 TIC1                      
     RTS                               
;                                      
;----- Power Off -----                 
;                                      
Z10  HZP=0                             
Z12  JNE Z12 HZS                       
     C0=C0 AND $FE                     
     TIC1=100                          
Z14  JNE Z14 TIC1                      
     SEVCC=0                           
     RTS                               
     END                               
